diff --git a/src/cmd/go/internal/work/init.go b/src/cmd/go/internal/work/init.go
index 9091f98636..8264377090 100644
--- a/src/cmd/go/internal/work/init.go
+++ b/src/cmd/go/internal/work/init.go
@@ -121,7 +121,7 @@ func buildModeInit() {
 			codegenArg = "-fPIC"
 		} else {
 			switch cfg.Goos {
-			case "linux", "android", "freebsd":
+			case "linux", "android", "freebsd", "openbsd":
 				codegenArg = "-shared"
 			case "windows":
 				// Do not add usual .exe suffix to the .dll file.
diff --git a/src/cmd/internal/sys/supported.go b/src/cmd/internal/sys/supported.go
index 02f833e945..f79b811f74 100644
--- a/src/cmd/internal/sys/supported.go
+++ b/src/cmd/internal/sys/supported.go
@@ -13,7 +13,7 @@ func RaceDetectorSupported(goos, goarch string) bool {
 	switch goos {
 	case "linux":
 		return goarch == "amd64" || goarch == "ppc64le" || goarch == "arm64"
-	case "darwin", "freebsd", "netbsd", "windows":
+	case "darwin", "freebsd", "netbsd", "openbsd", "windows":
 		return goarch == "amd64"
 	default:
 		return false
@@ -67,6 +67,7 @@ func BuildModeSupported(compiler, buildmode, goos, goarch string) bool {
 		case "linux/amd64", "linux/arm", "linux/arm64", "linux/386", "linux/ppc64le", "linux/s390x",
 			"android/amd64", "android/arm", "android/arm64", "android/386",
 			"freebsd/amd64",
+			"openbsd/amd64",
 			"darwin/amd64", "darwin/386",
 			"windows/amd64", "windows/386":
 			return true
@@ -84,6 +85,7 @@ func BuildModeSupported(compiler, buildmode, goos, goarch string) bool {
 		case "linux/386", "linux/amd64", "linux/arm", "linux/arm64", "linux/ppc64le", "linux/s390x",
 			"android/amd64", "android/arm", "android/arm64", "android/386",
 			"freebsd/amd64",
+			"openbsd/amd64",
 			"darwin/amd64",
 			"aix/ppc64":
 			return true
@@ -102,7 +104,8 @@ func BuildModeSupported(compiler, buildmode, goos, goarch string) bool {
 		case "linux/amd64", "linux/arm", "linux/arm64", "linux/386", "linux/s390x", "linux/ppc64le",
 			"android/amd64", "android/arm", "android/arm64", "android/386",
 			"darwin/amd64",
-			"freebsd/amd64":
+			"freebsd/amd64",
+			"openbsd/amd64":
 			return true
 		}
 		return false
diff --git a/src/cmd/link/internal/ld/config.go b/src/cmd/link/internal/ld/config.go
index dcbe136832..139afe51b8 100644
--- a/src/cmd/link/internal/ld/config.go
+++ b/src/cmd/link/internal/ld/config.go
@@ -39,7 +39,7 @@ func (mode *BuildMode) Set(s string) error {
 	case "pie":
 		switch objabi.GOOS {
 		case "aix", "android", "linux":
-		case "darwin", "freebsd":
+		case "darwin", "freebsd", "openbsd":
 			switch objabi.GOARCH {
 			case "amd64":
 			default:
@@ -52,7 +52,7 @@ func (mode *BuildMode) Set(s string) error {
 	case "c-archive":
 		switch objabi.GOOS {
 		case "aix", "darwin", "linux":
-		case "freebsd":
+		case "freebsd", "openbsd":
 			switch objabi.GOARCH {
 			case "amd64":
 			default:
@@ -95,7 +95,7 @@ func (mode *BuildMode) Set(s string) error {
 			default:
 				return badmode()
 			}
-		case "darwin", "freebsd":
+		case "darwin", "freebsd", "openbsd":
 			switch objabi.GOARCH {
 			case "amd64":
 			default:
diff --git a/src/cmd/link/internal/ld/lib.go b/src/cmd/link/internal/ld/lib.go
index 45cc87287c..82ba071bd7 100644
--- a/src/cmd/link/internal/ld/lib.go
+++ b/src/cmd/link/internal/ld/lib.go
@@ -1221,8 +1221,6 @@ func (ctxt *Link) hostlink() {
 		if ctxt.DynlinkingGo() && !ctxt.Arch.InFamily(sys.ARM, sys.ARM64) {
 			argv = append(argv, "-Wl,-flat_namespace")
 		}
-	case objabi.Hopenbsd:
-		argv = append(argv, "-Wl,-nopie")
 	case objabi.Hwindows:
 		if windowsgui {
 			argv = append(argv, "-mwindows")
